Package org.apache.groovy.parser.antlr4

# Class AstBuilder

java.lang.Object
org.antlr.v4.runtime.tree.AbstractParseTreeVisitor<Result>
org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>
org.apache.groovy.parser.antlr4.AstBuilder

All Implemented Interfaces:
  `org.antlr.v4.runtime.tree.ParseTreeVisitor<Object>`, `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`

public class AstBuilder extends org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>
Builds the AST from the parse tree generated by Antlr4.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AstBuilder(SourceUnit sourceUnit, boolean groovydocEnabled, boolean runtimeGroovydocEnabled)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `BlockStatement`
  `appendStatementsToBlockStatement(BlockStatement bs, Statement... statements)`
  `ModuleNode`
  `buildAST()`
  `Object`
  `visit(org.antlr.v4.runtime.tree.ParseTree tree)`
  Visit tree safely, no NPE occurred when the tree is null.
  `BinaryExpression`
  `visitAdditiveExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.AdditiveExprAltContext ctx)`
  `BinaryExpression`
  `visitAndExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.AndExprAltContext ctx)`
  `ClassNode`
  `visitAnnotatedQualifiedClassName(org.apache.groovy.parser.antlr4.GroovyParser.AnnotatedQualifiedClassNameContext ctx)`
  `AnnotationNode`
  `visitAnnotation(org.apache.groovy.parser.antlr4.GroovyParser.AnnotationContext ctx)`
  `String`
  `visitAnnotationName(org.apache.groovy.parser.antlr4.GroovyParser.AnnotationNameContext ctx)`
  `List<AnnotationNode>`
  `visitAnnotationsOpt(org.apache.groovy.parser.antlr4.GroovyParser.AnnotationsOptContext ctx)`
  `InnerClassNode`
  `visitAnonymousInnerClassDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.AnonymousInnerClassDeclarationContext ctx)`
  `Expression`
  `visitArguments(org.apache.groovy.parser.antlr4.GroovyParser.ArgumentsContext ctx)`
  `List<Expression>`
  `visitArrayInitializer(org.apache.groovy.parser.antlr4.GroovyParser.ArrayInitializerContext ctx)`
  `AssertStatement`
  `visitAssertStatement(org.apache.groovy.parser.antlr4.GroovyParser.AssertStatementContext ctx)`
  `BinaryExpression`
  `visitAssignmentExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.AssignmentExprAltContext ctx)`
  `Statement`
  `visitBlock(org.apache.groovy.parser.antlr4.GroovyParser.BlockContext ctx)`
  `Statement`
  `visitBlockStatement(org.apache.groovy.parser.antlr4.GroovyParser.BlockStatementContext ctx)`
  `BlockStatement`
  `visitBlockStatements(org.apache.groovy.parser.antlr4.GroovyParser.BlockStatementsContext ctx)`
  `BlockStatement`
  `visitBlockStatementsOpt(org.apache.groovy.parser.antlr4.GroovyParser.BlockStatementsOptContext ctx)`
  `ConstantExpression`
  `visitBooleanLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser.BooleanLiteralAltContext ctx)`
  `BreakStatement`
  `visitBreakStatement(org.apache.groovy.parser.antlr4.GroovyParser.BreakStatementContext ctx)`
  `VariableExpression`
  `visitBuiltInType(org.apache.groovy.parser.antlr4.GroovyParser.BuiltInTypeContext ctx)`
  `CastExpression`
  `visitCastExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.CastExprAltContext ctx)`
  `ClassNode`
  `visitCastParExpression(org.apache.groovy.parser.antlr4.GroovyParser.CastParExpressionContext ctx)`
  `List<CatchStatement>`
  `visitCatchClause(org.apache.groovy.parser.antlr4.GroovyParser.CatchClauseContext ctx)`
  Multi-catch(1..*) clause will be unpacked to several normal catch clauses, so the return type is List
  `List<ClassNode>`
  `visitCatchType(org.apache.groovy.parser.antlr4.GroovyParser.CatchTypeContext ctx)`
  `Void`
  `visitClassBody(org.apache.groovy.parser.antlr4.GroovyParser.ClassBodyContext ctx)`
  `Void`
  `visitClassBodyDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.ClassBodyDeclarationContext ctx)`
  `ClassNode`
  `visitClassDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.ClassDeclarationContext ctx)`
  `Tuple2<Parameter,Expression>`
  `visitClassicalForControl(org.apache.groovy.parser.antlr4.GroovyParser.ClassicalForControlContext ctx)`
  `String`
  `visitClassName(org.apache.groovy.parser.antlr4.GroovyParser.ClassNameContext ctx)`
  `ModifierNode`
  `visitClassOrInterfaceModifier(org.apache.groovy.parser.antlr4.GroovyParser.ClassOrInterfaceModifierContext ctx)`
  `List<ModifierNode>`
  `visitClassOrInterfaceModifiers(org.apache.groovy.parser.antlr4.GroovyParser.ClassOrInterfaceModifiersContext ctx)`
  `List<ModifierNode>`
  `visitClassOrInterfaceModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser.ClassOrInterfaceModifiersOptContext ctx)`
  `ClassNode`
  `visitClassOrInterfaceType(org.apache.groovy.parser.antlr4.GroovyParser.ClassOrInterfaceTypeContext ctx)`
  `ClosureExpression`
  `visitClosure(org.apache.groovy.parser.antlr4.GroovyParser.ClosureContext ctx)`
  `ClosureExpression`
  `visitClosureOrLambdaExpression(org.apache.groovy.parser.antlr4.GroovyParser.ClosureOrLambdaExpressionContext ctx)`
  `Expression`
  `visitCommandArgument(org.apache.groovy.parser.antlr4.GroovyParser.CommandArgumentContext ctx)`
  `ExpressionStatement`
  `visitCommandExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.CommandExprAltContext ctx)`
  `Expression`
  `visitCommandExpression(org.apache.groovy.parser.antlr4.GroovyParser.CommandExpressionContext ctx)`
  `MethodNode`
  `visitCompactConstructorDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.CompactConstructorDeclarationContext ctx)`
  `ModuleNode`
  `visitCompilationUnit(org.apache.groovy.parser.antlr4.GroovyParser.CompilationUnitContext ctx)`
  `Expression`
  `visitConditionalExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.ConditionalExprAltContext ctx)`
  `Statement`
  `visitConditionalStatement(org.apache.groovy.parser.antlr4.GroovyParser.ConditionalStatementContext ctx)`
  `ContinueStatement`
  `visitContinueStatement(org.apache.groovy.parser.antlr4.GroovyParser.ContinueStatementContext ctx)`
  `ClassNode`
  `visitCreatedName(org.apache.groovy.parser.antlr4.GroovyParser.CreatedNameContext ctx)`
  `Expression`
  `visitCreator(org.apache.groovy.parser.antlr4.GroovyParser.CreatorContext ctx)`
  `Tuple3<Expression,List<AnnotationNode>,org.antlr.v4.runtime.tree.TerminalNode>`
  `visitDim(org.apache.groovy.parser.antlr4.GroovyParser.DimContext ctx)`
  `DoWhileStatement`
  `visitDoWhileStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.DoWhileStmtAltContext ctx)`
  `Expression`
  `visitDynamicMemberName(org.apache.groovy.parser.antlr4.GroovyParser.DynamicMemberNameContext ctx)`
  `Expression`
  `visitElementValue(org.apache.groovy.parser.antlr4.GroovyParser.ElementValueContext ctx)`
  `ListExpression`
  `visitElementValueArrayInitializer(org.apache.groovy.parser.antlr4.GroovyParser.ElementValueArrayInitializerContext ctx)`
  `Tuple2<String,Expression>`
  `visitElementValuePair(org.apache.groovy.parser.antlr4.GroovyParser.ElementValuePairContext ctx)`
  `Map<String,Expression>`
  `visitElementValuePairs(org.apache.groovy.parser.antlr4.GroovyParser.ElementValuePairsContext ctx)`
  `List<Tuple2<String,Expression>>`
  `visitElementValues(org.apache.groovy.parser.antlr4.GroovyParser.ElementValuesContext ctx)`
  `List<List<AnnotationNode>>`
  `visitEmptyDims(org.apache.groovy.parser.antlr4.GroovyParser.EmptyDimsContext ctx)`
  `List<List<AnnotationNode>>`
  `visitEmptyDimsOpt(org.apache.groovy.parser.antlr4.GroovyParser.EmptyDimsOptContext ctx)`
  `Expression`
  `visitEnhancedArgumentListElement(org.apache.groovy.parser.antlr4.GroovyParser.EnhancedArgumentListElementContext ctx)`
  `Expression`
  `visitEnhancedArgumentListInPar(org.apache.groovy.parser.antlr4.GroovyParser.EnhancedArgumentListInParContext ctx)`
  `Tuple2<Parameter,Expression>`
  `visitEnhancedForControl(org.apache.groovy.parser.antlr4.GroovyParser.EnhancedForControlContext ctx)`
  `Expression`
  `visitEnhancedStatementExpression(org.apache.groovy.parser.antlr4.GroovyParser.EnhancedStatementExpressionContext ctx)`
  `FieldNode`
  `visitEnumConstant(org.apache.groovy.parser.antlr4.GroovyParser.EnumConstantContext ctx)`
  `List<FieldNode>`
  `visitEnumConstants(org.apache.groovy.parser.antlr4.GroovyParser.EnumConstantsContext ctx)`
  `BinaryExpression`
  `visitEqualityExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.EqualityExprAltContext ctx)`
  `BinaryExpression`
  `visitExclusiveOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.ExclusiveOrExprAltContext ctx)`
  `Expression`
  `visitExpressionInPar(org.apache.groovy.parser.antlr4.GroovyParser.ExpressionInParContext ctx)`
  `List<Expression>`
  `visitExpressionList(org.apache.groovy.parser.antlr4.GroovyParser.ExpressionListContext ctx)`
  `Expression`
  `visitExpressionListElement(org.apache.groovy.parser.antlr4.GroovyParser.ExpressionListElementContext ctx)`
  `Void`
  `visitFieldDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.FieldDeclarationContext ctx)`
  `Statement`
  `visitFinallyBlock(org.apache.groovy.parser.antlr4.GroovyParser.FinallyBlockContext ctx)`
  `ConstantExpression`
  `visitFloatingPointLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser.FloatingPointLiteralAltContext ctx)`
  `Tuple2<Parameter,Expression>`
  `visitForControl(org.apache.groovy.parser.antlr4.GroovyParser.ForControlContext ctx)`
  `Expression`
  `visitForInit(org.apache.groovy.parser.antlr4.GroovyParser.ForInitContext ctx)`
  `Parameter`
  `visitFormalParameter(org.apache.groovy.parser.antlr4.GroovyParser.FormalParameterContext ctx)`
  `Parameter[]`
  `visitFormalParameterList(org.apache.groovy.parser.antlr4.GroovyParser.FormalParameterListContext ctx)`
  `Parameter[]`
  `visitFormalParameters(org.apache.groovy.parser.antlr4.GroovyParser.FormalParametersContext ctx)`
  `ForStatement`
  `visitForStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.ForStmtAltContext ctx)`
  `Expression`
  `visitForUpdate(org.apache.groovy.parser.antlr4.GroovyParser.ForUpdateContext ctx)`
  `GStringExpression`
  `visitGstring(org.apache.groovy.parser.antlr4.GroovyParser.GstringContext ctx)`
  `Expression`
  `visitGstringPath(org.apache.groovy.parser.antlr4.GroovyParser.GstringPathContext ctx)`
  `Expression`
  `visitGstringValue(org.apache.groovy.parser.antlr4.GroovyParser.GstringValueContext ctx)`
  `String`
  `visitIdentifier(org.apache.groovy.parser.antlr4.GroovyParser.IdentifierContext ctx)`
  `Expression`
  `visitIdentifierPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser.IdentifierPrmrAltContext ctx)`
  `IfStatement`
  `visitIfElseStatement(org.apache.groovy.parser.antlr4.GroovyParser.IfElseStatementContext ctx)`
  `ImportNode`
  `visitImportDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.ImportDeclarationContext ctx)`
  `BinaryExpression`
  `visitInclusiveOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.InclusiveOrExprAltContext ctx)`
  `Tuple2<org.antlr.v4.runtime.Token,Expression>`
  `visitIndexPropertyArgs(org.apache.groovy.parser.antlr4.GroovyParser.IndexPropertyArgsContext ctx)`
  `ConstantExpression`
  `visitIntegerLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser.IntegerLiteralAltContext ctx)`
  `ConstantExpression`
  `visitKeywords(org.apache.groovy.parser.antlr4.GroovyParser.KeywordsContext ctx)`
  `Statement`
  `visitLabeledStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.LabeledStmtAltContext ctx)`
  `Statement`
  `visitLambdaBody(org.apache.groovy.parser.antlr4.GroovyParser.LambdaBodyContext ctx)`
  `ListExpression`
  `visitList(org.apache.groovy.parser.antlr4.GroovyParser.ListContext ctx)`
  `org.apache.groovy.parser.antlr4.AstBuilder.DeclarationListStatement`
  `visitLocalVariableDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.LocalVariableDeclarationContext ctx)`
  `BinaryExpression`
  `visitLogicalAndExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.LogicalAndExprAltContext ctx)`
  `BinaryExpression`
  `visitLogicalOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.LogicalOrExprAltContext ctx)`
  `Statement`
  `visitLoopStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.LoopStmtAltContext ctx)`
  `MapExpression`
  `visitMap(org.apache.groovy.parser.antlr4.GroovyParser.MapContext ctx)`
  `MapEntryExpression`
  `visitMapEntry(org.apache.groovy.parser.antlr4.GroovyParser.MapEntryContext ctx)`
  `Expression`
  `visitMapEntryLabel(org.apache.groovy.parser.antlr4.GroovyParser.MapEntryLabelContext ctx)`
  `List<MapEntryExpression>`
  `visitMapEntryList(org.apache.groovy.parser.antlr4.GroovyParser.MapEntryListContext ctx)`
  `Void`
  `visitMemberDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.MemberDeclarationContext ctx)`
  `Statement`
  `visitMethodBody(org.apache.groovy.parser.antlr4.GroovyParser.MethodBodyContext ctx)`
  `MethodNode`
  `visitMethodDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.MethodDeclarationContext ctx)`
  `String`
  `visitMethodName(org.apache.groovy.parser.antlr4.GroovyParser.MethodNameContext ctx)`
  `ModifierNode`
  `visitModifier(org.apache.groovy.parser.antlr4.GroovyParser.ModifierContext ctx)`
  `List<ModifierNode>`
  `visitModifiers(org.apache.groovy.parser.antlr4.GroovyParser.ModifiersContext ctx)`
  `List<ModifierNode>`
  `visitModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser.ModifiersOptContext ctx)`
  `BinaryExpression`
  `visitMultipleAssignmentExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.MultipleAssignmentExprAltContext ctx)`
  `BinaryExpression`
  `visitMultiplicativeExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.MultiplicativeExprAltContext ctx)`
  `List<MapEntryExpression>`
  `visitNamedPropertyArgs(org.apache.groovy.parser.antlr4.GroovyParser.NamedPropertyArgsContext ctx)`
  `Expression`
  `visitNamePart(org.apache.groovy.parser.antlr4.GroovyParser.NamePartContext ctx)`
  `Expression`
  `visitNewPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser.NewPrmrAltContext ctx)`
  `GenericsType[]`
  `visitNonWildcardTypeArguments(org.apache.groovy.parser.antlr4.GroovyParser.NonWildcardTypeArgumentsContext ctx)`
  `ConstantExpression`
  `visitNullLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser.NullLiteralAltContext ctx)`
  `PackageNode`
  `visitPackageDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.PackageDeclarationContext ctx)`
  `Expression`
  `visitParExpression(org.apache.groovy.parser.antlr4.GroovyParser.ParExpressionContext ctx)`
  `Expression`
  `visitPathElement(org.apache.groovy.parser.antlr4.GroovyParser.PathElementContext ctx)`
  `Expression`
  `visitPathExpression(org.apache.groovy.parser.antlr4.GroovyParser.PathExpressionContext ctx)`
  `Expression`
  `visitPostfixExpression(org.apache.groovy.parser.antlr4.GroovyParser.PostfixExpressionContext ctx)`
  `BinaryExpression`
  `visitPowerExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.PowerExprAltContext ctx)`
  `ClassNode`
  `visitPrimitiveType(org.apache.groovy.parser.antlr4.GroovyParser.PrimitiveTypeContext ctx)`
  `ClassNode`
  `visitQualifiedClassName(org.apache.groovy.parser.antlr4.GroovyParser.QualifiedClassNameContext ctx)`
  `ClassNode[]`
  `visitQualifiedClassNameList(org.apache.groovy.parser.antlr4.GroovyParser.QualifiedClassNameListContext ctx)`
  `String`
  `visitQualifiedName(org.apache.groovy.parser.antlr4.GroovyParser.QualifiedNameContext ctx)`
  `ClassNode`
  `visitQualifiedStandardClassName(org.apache.groovy.parser.antlr4.GroovyParser.QualifiedStandardClassNameContext ctx)`
  `BinaryExpression`
  `visitRegexExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.RegexExprAltContext ctx)`
  `Expression`
  `visitRelationalExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.RelationalExprAltContext ctx)`
  `ExpressionStatement`
  `visitResource(org.apache.groovy.parser.antlr4.GroovyParser.ResourceContext ctx)`
  `List<ExpressionStatement>`
  `visitResourceList(org.apache.groovy.parser.antlr4.GroovyParser.ResourceListContext ctx)`
  `List<ExpressionStatement>`
  `visitResources(org.apache.groovy.parser.antlr4.GroovyParser.ResourcesContext ctx)`
  `ReturnStatement`
  `visitReturnStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.ReturnStmtAltContext ctx)`
  `ClassNode`
  `visitReturnType(org.apache.groovy.parser.antlr4.GroovyParser.ReturnTypeContext ctx)`
  `List<ASTNode>`
  `visitScriptStatements(org.apache.groovy.parser.antlr4.GroovyParser.ScriptStatementsContext ctx)`
  `Expression`
  `visitShiftExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.ShiftExprAltContext ctx)`
  `LambdaExpression`
  `visitStandardLambdaExpression(org.apache.groovy.parser.antlr4.GroovyParser.StandardLambdaExpressionContext ctx)`
  `Parameter[]`
  `visitStandardLambdaParameters(org.apache.groovy.parser.antlr4.GroovyParser.StandardLambdaParametersContext ctx)`
  `ConstantExpression`
  `visitStringLiteral(org.apache.groovy.parser.antlr4.GroovyParser.StringLiteralContext ctx)`
  `VariableExpression`
  `visitSuperPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser.SuperPrmrAltContext ctx)`
  `Tuple3<List<Statement>,Boolean,Boolean>`
  `visitSwitchBlockStatementExpressionGroup(org.apache.groovy.parser.antlr4.GroovyParser.SwitchBlockStatementExpressionGroupContext ctx)`
  `List<Statement>`
  `visitSwitchBlockStatementGroup(org.apache.groovy.parser.antlr4.GroovyParser.SwitchBlockStatementGroupContext ctx)`
  `Expression`
  `visitSwitchExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.SwitchExprAltContext ctx)`
  `MethodCallExpression`
  `visitSwitchExpression(org.apache.groovy.parser.antlr4.GroovyParser.SwitchExpressionContext ctx)`
  switch(a) { case 0, 1 -> 'a'; case 2 -> 'b'; default -> 'z'; }
  `Tuple3<org.antlr.v4.runtime.Token,List<Expression>,Integer>`
  `visitSwitchExpressionLabel(org.apache.groovy.parser.antlr4.GroovyParser.SwitchExpressionLabelContext ctx)`
  `Tuple2<org.antlr.v4.runtime.Token,Expression>`
  `visitSwitchLabel(org.apache.groovy.parser.antlr4.GroovyParser.SwitchLabelContext ctx)`
  `SwitchStatement`
  `visitSwitchStatement(org.apache.groovy.parser.antlr4.GroovyParser.SwitchStatementContext ctx)`
  `SynchronizedStatement`
  `visitSynchronizedStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.SynchronizedStmtAltContext ctx)`
  `Parameter`
  `visitThisFormalParameter(org.apache.groovy.parser.antlr4.GroovyParser.ThisFormalParameterContext ctx)`
  `VariableExpression`
  `visitThisPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser.ThisPrmrAltContext ctx)`
  `ThrowStatement`
  `visitThrowStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.ThrowStmtAltContext ctx)`
  `Statement`
  `visitTryCatchStatement(org.apache.groovy.parser.antlr4.GroovyParser.TryCatchStatementContext ctx)`
  `ClassNode`
  `visitType(org.apache.groovy.parser.antlr4.GroovyParser.TypeContext ctx)`
  `GenericsType`
  `visitTypeArgument(org.apache.groovy.parser.antlr4.GroovyParser.TypeArgumentContext ctx)`
  `GenericsType[]`
  `visitTypeArguments(org.apache.groovy.parser.antlr4.GroovyParser.TypeArgumentsContext ctx)`
  `GenericsType[]`
  `visitTypeArgumentsOrDiamond(org.apache.groovy.parser.antlr4.GroovyParser.TypeArgumentsOrDiamondContext ctx)`
  `ClassNode[]`
  `visitTypeBound(org.apache.groovy.parser.antlr4.GroovyParser.TypeBoundContext ctx)`
  `ClassNode`
  `visitTypeDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.TypeDeclarationContext ctx)`
  `ClassNode[]`
  `visitTypeList(org.apache.groovy.parser.antlr4.GroovyParser.TypeListContext ctx)`
  `VariableExpression`
  `visitTypeNamePair(org.apache.groovy.parser.antlr4.GroovyParser.TypeNamePairContext ctx)`
  `List<Expression>`
  `visitTypeNamePairs(org.apache.groovy.parser.antlr4.GroovyParser.TypeNamePairsContext ctx)`
  `GenericsType`
  `visitTypeParameter(org.apache.groovy.parser.antlr4.GroovyParser.TypeParameterContext ctx)`
  `GenericsType[]`
  `visitTypeParameters(org.apache.groovy.parser.antlr4.GroovyParser.TypeParametersContext ctx)`
  `Expression`
  `visitUnaryAddExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.UnaryAddExprAltContext ctx)`
  `Expression`
  `visitUnaryNotExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.UnaryNotExprAltContext ctx)`
  `org.apache.groovy.parser.antlr4.AstBuilder.DeclarationListStatement`
  `visitVariableDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.VariableDeclarationContext ctx)`
  `DeclarationExpression`
  `visitVariableDeclarator(org.apache.groovy.parser.antlr4.GroovyParser.VariableDeclaratorContext ctx)`
  `VariableExpression`
  `visitVariableDeclaratorId(org.apache.groovy.parser.antlr4.GroovyParser.VariableDeclaratorIdContext ctx)`
  `List<DeclarationExpression>`
  `visitVariableDeclarators(org.apache.groovy.parser.antlr4.GroovyParser.VariableDeclaratorsContext ctx)`
  `Expression`
  `visitVariableInitializer(org.apache.groovy.parser.antlr4.GroovyParser.VariableInitializerContext ctx)`
  `List<Expression>`
  `visitVariableInitializers(org.apache.groovy.parser.antlr4.GroovyParser.VariableInitializersContext ctx)`
  `ModifierNode`
  `visitVariableModifier(org.apache.groovy.parser.antlr4.GroovyParser.VariableModifierContext ctx)`
  `List<ModifierNode>`
  `visitVariableModifiers(org.apache.groovy.parser.antlr4.GroovyParser.VariableModifiersContext ctx)`
  `List<ModifierNode>`
  `visitVariableModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser.VariableModifiersOptContext ctx)`
  `TupleExpression`
  `visitVariableNames(org.apache.groovy.parser.antlr4.GroovyParser.VariableNamesContext ctx)`
  `WhileStatement`
  `visitWhileStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.WhileStmtAltContext ctx)`
  `ReturnStatement`
  `visitYieldStatement(org.apache.groovy.parser.antlr4.GroovyParser.YieldStatementContext ctx)`
  `ReturnStatement`
  `visitYieldStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.YieldStmtAltContext ctx)`

  ### Methods inherited from class org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor

  `visitAssertStmtAlt, visitBlockStmtAlt, visitBreakStmtAlt, visitBuiltInTypePrmrAlt, visitClosureOrLambdaExpressionPrmrAlt, visitConditionalStmtAlt, visitContinueStmtAlt, visitElementValuePairName, visitEmptyStmtAlt, visitExpression, visitExpressionStmtAlt, visitGstringPrmrAlt, visitListPrmrAlt, visitLiteral, visitLiteralPrmrAlt, visitLocalVariableDeclarationStmtAlt, visitLoopStatement, visitMapPrmrAlt, visitNls, visitParenPrmrAlt, visitPostfixExprAlt, visitPrimary, visitQualifiedNameElement, visitQualifiedNameElements, visitRparen, visitScriptStatement, visitSep, visitStatement, visitStatementExpression, visitStringLiteralAlt, visitTryCatchStmtAlt`

  ### Methods inherited from class org.antlr.v4.runtime.tree.AbstractParseTreeVisitor

  `aggregateResult, defaultResult, shouldVisitNextChild, visitChildren, visitErrorNode, visitTerminal`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.antlr.v4.runtime.tree.ParseTreeVisitor

  `visitChildren, visitErrorNode, visitTerminal`

- ## Constructor Details

  - ### AstBuilder

    public AstBuilder(SourceUnit sourceUnit, boolean groovydocEnabled, boolean runtimeGroovydocEnabled)

- ## Method Details

  - ### buildAST

    public ModuleNode buildAST()

  - ### visitCompilationUnit

    public ModuleNode visitCompilationUnit(org.apache.groovy.parser.antlr4.GroovyParser.CompilationUnitContext ctx)
    Specified by:
      `visitCompilationUnit` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitCompilationUnit` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitScriptStatements

    public List<ASTNode> visitScriptStatements(org.apache.groovy.parser.antlr4.GroovyParser.ScriptStatementsContext ctx)
    Specified by:
      `visitScriptStatements` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitScriptStatements` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitPackageDeclaration

    public PackageNode visitPackageDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.PackageDeclarationContext ctx)
    Specified by:
      `visitPackageDeclaration` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitPackageDeclaration` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitImportDeclaration

    public ImportNode visitImportDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.ImportDeclarationContext ctx)
    Specified by:
      `visitImportDeclaration` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitImportDeclaration` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitAssertStatement

    public AssertStatement visitAssertStatement(org.apache.groovy.parser.antlr4.GroovyParser.AssertStatementContext ctx)
    Specified by:
      `visitAssertStatement` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitAssertStatement` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitConditionalStatement

    public Statement visitConditionalStatement(org.apache.groovy.parser.antlr4.GroovyParser.ConditionalStatementContext ctx)
    Specified by:
      `visitConditionalStatement` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitConditionalStatement` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitIfElseStatement

    public IfStatement visitIfElseStatement(org.apache.groovy.parser.antlr4.GroovyParser.IfElseStatementContext ctx)
    Specified by:
      `visitIfElseStatement` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitIfElseStatement` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitLoopStmtAlt

    public Statement visitLoopStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.LoopStmtAltContext ctx)
    Specified by:
      `visitLoopStmtAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitLoopStmtAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitForStmtAlt

    public ForStatement visitForStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.ForStmtAltContext ctx)
    Specified by:
      `visitForStmtAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitForStmtAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitForControl

    public Tuple2<Parameter,Expression> visitForControl(org.apache.groovy.parser.antlr4.GroovyParser.ForControlContext ctx)
    Specified by:
      `visitForControl` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitForControl` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitForInit

    public Expression visitForInit(org.apache.groovy.parser.antlr4.GroovyParser.ForInitContext ctx)
    Specified by:
      `visitForInit` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitForInit` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitForUpdate

    public Expression visitForUpdate(org.apache.groovy.parser.antlr4.GroovyParser.ForUpdateContext ctx)
    Specified by:
      `visitForUpdate` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitForUpdate` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitEnhancedForControl

    public Tuple2<Parameter,Expression> visitEnhancedForControl(org.apache.groovy.parser.antlr4.GroovyParser.EnhancedForControlContext ctx)
    Specified by:
      `visitEnhancedForControl` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitEnhancedForControl` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitClassicalForControl

    public Tuple2<Parameter,Expression> visitClassicalForControl(org.apache.groovy.parser.antlr4.GroovyParser.ClassicalForControlContext ctx)
    Specified by:
      `visitClassicalForControl` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitClassicalForControl` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitWhileStmtAlt

    public WhileStatement visitWhileStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.WhileStmtAltContext ctx)
    Specified by:
      `visitWhileStmtAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitWhileStmtAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitDoWhileStmtAlt

    public DoWhileStatement visitDoWhileStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.DoWhileStmtAltContext ctx)
    Specified by:
      `visitDoWhileStmtAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitDoWhileStmtAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitTryCatchStatement

    public Statement visitTryCatchStatement(org.apache.groovy.parser.antlr4.GroovyParser.TryCatchStatementContext ctx)
    Specified by:
      `visitTryCatchStatement` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitTryCatchStatement` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitResources

    public List<ExpressionStatement> visitResources(org.apache.groovy.parser.antlr4.GroovyParser.ResourcesContext ctx)
    Specified by:
      `visitResources` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitResources` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitResourceList

    public List<ExpressionStatement> visitResourceList(org.apache.groovy.parser.antlr4.GroovyParser.ResourceListContext ctx)
    Specified by:
      `visitResourceList` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitResourceList` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitResource

    public ExpressionStatement visitResource(org.apache.groovy.parser.antlr4.GroovyParser.ResourceContext ctx)
    Specified by:
      `visitResource` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitResource` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitCatchClause

    public List<CatchStatement> visitCatchClause(org.apache.groovy.parser.antlr4.GroovyParser.CatchClauseContext ctx)
    Multi-catch(1..*) clause will be unpacked to several normal catch clauses, so the return type is List
    Specified by:
      `visitCatchClause` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitCatchClause` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`
    Parameters:
      `ctx` - the parse tree
    Returns:
      a list of CatchStatement instances

  - ### visitCatchType

    public List<ClassNode> visitCatchType(org.apache.groovy.parser.antlr4.GroovyParser.CatchTypeContext ctx)
    Specified by:
      `visitCatchType` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitCatchType` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitFinallyBlock

    public Statement visitFinallyBlock(org.apache.groovy.parser.antlr4.GroovyParser.FinallyBlockContext ctx)
    Specified by:
      `visitFinallyBlock` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitFinallyBlock` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitSwitchStatement

    public SwitchStatement visitSwitchStatement(org.apache.groovy.parser.antlr4.GroovyParser.SwitchStatementContext ctx)
    Specified by:
      `visitSwitchStatement` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitSwitchStatement` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitSwitchBlockStatementGroup

    public List<Statement> visitSwitchBlockStatementGroup(org.apache.groovy.parser.antlr4.GroovyParser.SwitchBlockStatementGroupContext ctx)
    Specified by:
      `visitSwitchBlockStatementGroup` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitSwitchBlockStatementGroup` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitSwitchLabel

    public Tuple2<org.antlr.v4.runtime.Token,Expression> visitSwitchLabel(org.apache.groovy.parser.antlr4.GroovyParser.SwitchLabelContext ctx)
    Specified by:
      `visitSwitchLabel` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitSwitchLabel` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitSynchronizedStmtAlt

    public SynchronizedStatement visitSynchronizedStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.SynchronizedStmtAltContext ctx)
    Specified by:
      `visitSynchronizedStmtAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitSynchronizedStmtAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitReturnStmtAlt

    public ReturnStatement visitReturnStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.ReturnStmtAltContext ctx)
    Specified by:
      `visitReturnStmtAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitReturnStmtAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitThrowStmtAlt

    public ThrowStatement visitThrowStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.ThrowStmtAltContext ctx)
    Specified by:
      `visitThrowStmtAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitThrowStmtAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitLabeledStmtAlt

    public Statement visitLabeledStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.LabeledStmtAltContext ctx)
    Specified by:
      `visitLabeledStmtAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitLabeledStmtAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitBreakStatement

    public BreakStatement visitBreakStatement(org.apache.groovy.parser.antlr4.GroovyParser.BreakStatementContext ctx)
    Specified by:
      `visitBreakStatement` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitBreakStatement` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitYieldStatement

    public ReturnStatement visitYieldStatement(org.apache.groovy.parser.antlr4.GroovyParser.YieldStatementContext ctx)
    Specified by:
      `visitYieldStatement` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitYieldStatement` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitYieldStmtAlt

    public ReturnStatement visitYieldStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser.YieldStmtAltContext ctx)
    Specified by:
      `visitYieldStmtAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitYieldStmtAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitContinueStatement

    public ContinueStatement visitContinueStatement(org.apache.groovy.parser.antlr4.GroovyParser.ContinueStatementContext ctx)
    Specified by:
      `visitContinueStatement` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitContinueStatement` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitSwitchExprAlt

    public Expression visitSwitchExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.SwitchExprAltContext ctx)
    Specified by:
      `visitSwitchExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitSwitchExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitSwitchExpression

    public MethodCallExpression visitSwitchExpression(org.apache.groovy.parser.antlr4.GroovyParser.SwitchExpressionContext ctx)

         switch(a) {
             case 0, 1  ->   'a';
             case 2     ->   'b';
             default    ->   'z';
         }

    the above code will be transformed to:

         {->
             switch(a) {
                 case 0:
                 case 1:  return 'a';
                 case 2:  return 'b';
                 default: return 'z';
             }
         }()

    Specified by:
      `visitSwitchExpression` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitSwitchExpression` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`
    Parameters:
      `ctx` - the parse tree
    Returns:
      `MethodCallExpression` instance

  - ### visitSwitchBlockStatementExpressionGroup

    public Tuple3<List<Statement>,Boolean,Boolean> visitSwitchBlockStatementExpressionGroup(org.apache.groovy.parser.antlr4.GroovyParser.SwitchBlockStatementExpressionGroupContext ctx)
    Specified by:
      `visitSwitchBlockStatementExpressionGroup` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitSwitchBlockStatementExpressionGroup` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitSwitchExpressionLabel

    public Tuple3<org.antlr.v4.runtime.Token,List<Expression>,Integer> visitSwitchExpressionLabel(org.apache.groovy.parser.antlr4.GroovyParser.SwitchExpressionLabelContext ctx)
    Specified by:
      `visitSwitchExpressionLabel` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitSwitchExpressionLabel` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitTypeDeclaration

    public ClassNode visitTypeDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.TypeDeclarationContext ctx)
    Specified by:
      `visitTypeDeclaration` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitTypeDeclaration` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitClassDeclaration

    public ClassNode visitClassDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.ClassDeclarationContext ctx)
    Specified by:
      `visitClassDeclaration` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitClassDeclaration` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitClassBody

    public Void visitClassBody(org.apache.groovy.parser.antlr4.GroovyParser.ClassBodyContext ctx)
    Specified by:
      `visitClassBody` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitClassBody` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitEnumConstants

    public List<FieldNode> visitEnumConstants(org.apache.groovy.parser.antlr4.GroovyParser.EnumConstantsContext ctx)
    Specified by:
      `visitEnumConstants` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitEnumConstants` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitEnumConstant

    public FieldNode visitEnumConstant(org.apache.groovy.parser.antlr4.GroovyParser.EnumConstantContext ctx)
    Specified by:
      `visitEnumConstant` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitEnumConstant` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitClassBodyDeclaration

    public Void visitClassBodyDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.ClassBodyDeclarationContext ctx)
    Specified by:
      `visitClassBodyDeclaration` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitClassBodyDeclaration` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitMemberDeclaration

    public Void visitMemberDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.MemberDeclarationContext ctx)
    Specified by:
      `visitMemberDeclaration` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitMemberDeclaration` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitTypeParameters

    public GenericsType[] visitTypeParameters(org.apache.groovy.parser.antlr4.GroovyParser.TypeParametersContext ctx)
    Specified by:
      `visitTypeParameters` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitTypeParameters` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitTypeParameter

    public GenericsType visitTypeParameter(org.apache.groovy.parser.antlr4.GroovyParser.TypeParameterContext ctx)
    Specified by:
      `visitTypeParameter` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitTypeParameter` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitTypeBound

    public ClassNode[] visitTypeBound(org.apache.groovy.parser.antlr4.GroovyParser.TypeBoundContext ctx)
    Specified by:
      `visitTypeBound` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitTypeBound` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitFieldDeclaration

    public Void visitFieldDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.FieldDeclarationContext ctx)
    Specified by:
      `visitFieldDeclaration` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitFieldDeclaration` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitCompactConstructorDeclaration

    public MethodNode visitCompactConstructorDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.CompactConstructorDeclarationContext ctx)
    Specified by:
      `visitCompactConstructorDeclaration` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitCompactConstructorDeclaration` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitMethodDeclaration

    public MethodNode visitMethodDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.MethodDeclarationContext ctx)
    Specified by:
      `visitMethodDeclaration` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitMethodDeclaration` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitMethodName

    public String visitMethodName(org.apache.groovy.parser.antlr4.GroovyParser.MethodNameContext ctx)
    Specified by:
      `visitMethodName` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitMethodName` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitReturnType

    public ClassNode visitReturnType(org.apache.groovy.parser.antlr4.GroovyParser.ReturnTypeContext ctx)
    Specified by:
      `visitReturnType` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitReturnType` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitMethodBody

    public Statement visitMethodBody(org.apache.groovy.parser.antlr4.GroovyParser.MethodBodyContext ctx)
    Specified by:
      `visitMethodBody` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitMethodBody` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitLocalVariableDeclaration

    public org.apache.groovy.parser.antlr4.AstBuilder.DeclarationListStatement visitLocalVariableDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.LocalVariableDeclarationContext ctx)
    Specified by:
      `visitLocalVariableDeclaration` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitLocalVariableDeclaration` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitVariableDeclaration

    public org.apache.groovy.parser.antlr4.AstBuilder.DeclarationListStatement visitVariableDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.VariableDeclarationContext ctx)
    Specified by:
      `visitVariableDeclaration` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitVariableDeclaration` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitTypeNamePairs

    public List<Expression> visitTypeNamePairs(org.apache.groovy.parser.antlr4.GroovyParser.TypeNamePairsContext ctx)
    Specified by:
      `visitTypeNamePairs` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitTypeNamePairs` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitTypeNamePair

    public VariableExpression visitTypeNamePair(org.apache.groovy.parser.antlr4.GroovyParser.TypeNamePairContext ctx)
    Specified by:
      `visitTypeNamePair` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitTypeNamePair` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitVariableDeclarators

    public List<DeclarationExpression> visitVariableDeclarators(org.apache.groovy.parser.antlr4.GroovyParser.VariableDeclaratorsContext ctx)
    Specified by:
      `visitVariableDeclarators` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitVariableDeclarators` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitVariableDeclarator

    public DeclarationExpression visitVariableDeclarator(org.apache.groovy.parser.antlr4.GroovyParser.VariableDeclaratorContext ctx)
    Specified by:
      `visitVariableDeclarator` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitVariableDeclarator` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitVariableInitializer

    public Expression visitVariableInitializer(org.apache.groovy.parser.antlr4.GroovyParser.VariableInitializerContext ctx)
    Specified by:
      `visitVariableInitializer` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitVariableInitializer` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitVariableInitializers

    public List<Expression> visitVariableInitializers(org.apache.groovy.parser.antlr4.GroovyParser.VariableInitializersContext ctx)
    Specified by:
      `visitVariableInitializers` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitVariableInitializers` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitArrayInitializer

    public List<Expression> visitArrayInitializer(org.apache.groovy.parser.antlr4.GroovyParser.ArrayInitializerContext ctx)
    Specified by:
      `visitArrayInitializer` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitArrayInitializer` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitBlock

    public Statement visitBlock(org.apache.groovy.parser.antlr4.GroovyParser.BlockContext ctx)
    Specified by:
      `visitBlock` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitBlock` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitCommandExprAlt

    public ExpressionStatement visitCommandExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.CommandExprAltContext ctx)
    Specified by:
      `visitCommandExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitCommandExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitCommandExpression

    public Expression visitCommandExpression(org.apache.groovy.parser.antlr4.GroovyParser.CommandExpressionContext ctx)
    Specified by:
      `visitCommandExpression` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitCommandExpression` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitCommandArgument

    public Expression visitCommandArgument(org.apache.groovy.parser.antlr4.GroovyParser.CommandArgumentContext ctx)
    Specified by:
      `visitCommandArgument` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitCommandArgument` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitCastParExpression

    public ClassNode visitCastParExpression(org.apache.groovy.parser.antlr4.GroovyParser.CastParExpressionContext ctx)
    Specified by:
      `visitCastParExpression` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitCastParExpression` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitParExpression

    public Expression visitParExpression(org.apache.groovy.parser.antlr4.GroovyParser.ParExpressionContext ctx)
    Specified by:
      `visitParExpression` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitParExpression` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitExpressionInPar

    public Expression visitExpressionInPar(org.apache.groovy.parser.antlr4.GroovyParser.ExpressionInParContext ctx)
    Specified by:
      `visitExpressionInPar` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitExpressionInPar` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitEnhancedStatementExpression

    public Expression visitEnhancedStatementExpression(org.apache.groovy.parser.antlr4.GroovyParser.EnhancedStatementExpressionContext ctx)
    Specified by:
      `visitEnhancedStatementExpression` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitEnhancedStatementExpression` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitPathExpression

    public Expression visitPathExpression(org.apache.groovy.parser.antlr4.GroovyParser.PathExpressionContext ctx)
    Specified by:
      `visitPathExpression` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitPathExpression` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitPathElement

    public Expression visitPathElement(org.apache.groovy.parser.antlr4.GroovyParser.PathElementContext ctx)
    Specified by:
      `visitPathElement` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitPathElement` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitNonWildcardTypeArguments

    public GenericsType[] visitNonWildcardTypeArguments(org.apache.groovy.parser.antlr4.GroovyParser.NonWildcardTypeArgumentsContext ctx)
    Specified by:
      `visitNonWildcardTypeArguments` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitNonWildcardTypeArguments` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitTypeList

    public ClassNode[] visitTypeList(org.apache.groovy.parser.antlr4.GroovyParser.TypeListContext ctx)
    Specified by:
      `visitTypeList` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitTypeList` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitArguments

    public Expression visitArguments(org.apache.groovy.parser.antlr4.GroovyParser.ArgumentsContext ctx)
    Specified by:
      `visitArguments` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitArguments` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitEnhancedArgumentListInPar

    public Expression visitEnhancedArgumentListInPar(org.apache.groovy.parser.antlr4.GroovyParser.EnhancedArgumentListInParContext ctx)
    Specified by:
      `visitEnhancedArgumentListInPar` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitEnhancedArgumentListInPar` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitEnhancedArgumentListElement

    public Expression visitEnhancedArgumentListElement(org.apache.groovy.parser.antlr4.GroovyParser.EnhancedArgumentListElementContext ctx)
    Specified by:
      `visitEnhancedArgumentListElement` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitEnhancedArgumentListElement` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitStringLiteral

    public ConstantExpression visitStringLiteral(org.apache.groovy.parser.antlr4.GroovyParser.StringLiteralContext ctx)
    Specified by:
      `visitStringLiteral` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitStringLiteral` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitIndexPropertyArgs

    public Tuple2<org.antlr.v4.runtime.Token,Expression> visitIndexPropertyArgs(org.apache.groovy.parser.antlr4.GroovyParser.IndexPropertyArgsContext ctx)
    Specified by:
      `visitIndexPropertyArgs` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitIndexPropertyArgs` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitNamedPropertyArgs

    public List<MapEntryExpression> visitNamedPropertyArgs(org.apache.groovy.parser.antlr4.GroovyParser.NamedPropertyArgsContext ctx)
    Specified by:
      `visitNamedPropertyArgs` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitNamedPropertyArgs` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitNamePart

    public Expression visitNamePart(org.apache.groovy.parser.antlr4.GroovyParser.NamePartContext ctx)
    Specified by:
      `visitNamePart` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitNamePart` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitDynamicMemberName

    public Expression visitDynamicMemberName(org.apache.groovy.parser.antlr4.GroovyParser.DynamicMemberNameContext ctx)
    Specified by:
      `visitDynamicMemberName` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitDynamicMemberName` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitPostfixExpression

    public Expression visitPostfixExpression(org.apache.groovy.parser.antlr4.GroovyParser.PostfixExpressionContext ctx)
    Specified by:
      `visitPostfixExpression` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitPostfixExpression` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitUnaryNotExprAlt

    public Expression visitUnaryNotExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.UnaryNotExprAltContext ctx)
    Specified by:
      `visitUnaryNotExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitUnaryNotExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitCastExprAlt

    public CastExpression visitCastExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.CastExprAltContext ctx)
    Specified by:
      `visitCastExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitCastExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitPowerExprAlt

    public BinaryExpression visitPowerExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.PowerExprAltContext ctx)
    Specified by:
      `visitPowerExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitPowerExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitUnaryAddExprAlt

    public Expression visitUnaryAddExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.UnaryAddExprAltContext ctx)
    Specified by:
      `visitUnaryAddExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitUnaryAddExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitMultiplicativeExprAlt

    public BinaryExpression visitMultiplicativeExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.MultiplicativeExprAltContext ctx)
    Specified by:
      `visitMultiplicativeExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitMultiplicativeExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitAdditiveExprAlt

    public BinaryExpression visitAdditiveExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.AdditiveExprAltContext ctx)
    Specified by:
      `visitAdditiveExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitAdditiveExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitShiftExprAlt

    public Expression visitShiftExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.ShiftExprAltContext ctx)
    Specified by:
      `visitShiftExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitShiftExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitRelationalExprAlt

    public Expression visitRelationalExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.RelationalExprAltContext ctx)
    Specified by:
      `visitRelationalExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitRelationalExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitEqualityExprAlt

    public BinaryExpression visitEqualityExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.EqualityExprAltContext ctx)
    Specified by:
      `visitEqualityExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitEqualityExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitRegexExprAlt

    public BinaryExpression visitRegexExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.RegexExprAltContext ctx)
    Specified by:
      `visitRegexExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitRegexExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitAndExprAlt

    public BinaryExpression visitAndExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.AndExprAltContext ctx)
    Specified by:
      `visitAndExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitAndExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitExclusiveOrExprAlt

    public BinaryExpression visitExclusiveOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.ExclusiveOrExprAltContext ctx)
    Specified by:
      `visitExclusiveOrExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitExclusiveOrExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitInclusiveOrExprAlt

    public BinaryExpression visitInclusiveOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.InclusiveOrExprAltContext ctx)
    Specified by:
      `visitInclusiveOrExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitInclusiveOrExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitLogicalAndExprAlt

    public BinaryExpression visitLogicalAndExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.LogicalAndExprAltContext ctx)
    Specified by:
      `visitLogicalAndExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitLogicalAndExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitLogicalOrExprAlt

    public BinaryExpression visitLogicalOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.LogicalOrExprAltContext ctx)
    Specified by:
      `visitLogicalOrExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitLogicalOrExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitConditionalExprAlt

    public Expression visitConditionalExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.ConditionalExprAltContext ctx)
    Specified by:
      `visitConditionalExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitConditionalExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitMultipleAssignmentExprAlt

    public BinaryExpression visitMultipleAssignmentExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.MultipleAssignmentExprAltContext ctx)
    Specified by:
      `visitMultipleAssignmentExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitMultipleAssignmentExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitAssignmentExprAlt

    public BinaryExpression visitAssignmentExprAlt(org.apache.groovy.parser.antlr4.GroovyParser.AssignmentExprAltContext ctx)
    Specified by:
      `visitAssignmentExprAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitAssignmentExprAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitIdentifierPrmrAlt

    public Expression visitIdentifierPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser.IdentifierPrmrAltContext ctx)
    Specified by:
      `visitIdentifierPrmrAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitIdentifierPrmrAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitNewPrmrAlt

    public Expression visitNewPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser.NewPrmrAltContext ctx)
    Specified by:
      `visitNewPrmrAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitNewPrmrAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitThisPrmrAlt

    public VariableExpression visitThisPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser.ThisPrmrAltContext ctx)
    Specified by:
      `visitThisPrmrAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitThisPrmrAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitSuperPrmrAlt

    public VariableExpression visitSuperPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser.SuperPrmrAltContext ctx)
    Specified by:
      `visitSuperPrmrAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitSuperPrmrAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitCreator

    public Expression visitCreator(org.apache.groovy.parser.antlr4.GroovyParser.CreatorContext ctx)
    Specified by:
      `visitCreator` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitCreator` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitDim

    public Tuple3<Expression,List<AnnotationNode>,org.antlr.v4.runtime.tree.TerminalNode> visitDim(org.apache.groovy.parser.antlr4.GroovyParser.DimContext ctx)
    Specified by:
      `visitDim` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitDim` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitAnonymousInnerClassDeclaration

    public InnerClassNode visitAnonymousInnerClassDeclaration(org.apache.groovy.parser.antlr4.GroovyParser.AnonymousInnerClassDeclarationContext ctx)
    Specified by:
      `visitAnonymousInnerClassDeclaration` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitAnonymousInnerClassDeclaration` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitCreatedName

    public ClassNode visitCreatedName(org.apache.groovy.parser.antlr4.GroovyParser.CreatedNameContext ctx)
    Specified by:
      `visitCreatedName` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitCreatedName` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitMap

    public MapExpression visitMap(org.apache.groovy.parser.antlr4.GroovyParser.MapContext ctx)
    Specified by:
      `visitMap` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitMap` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitMapEntryList

    public List<MapEntryExpression> visitMapEntryList(org.apache.groovy.parser.antlr4.GroovyParser.MapEntryListContext ctx)
    Specified by:
      `visitMapEntryList` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitMapEntryList` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitMapEntry

    public MapEntryExpression visitMapEntry(org.apache.groovy.parser.antlr4.GroovyParser.MapEntryContext ctx)
    Specified by:
      `visitMapEntry` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitMapEntry` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitMapEntryLabel

    public Expression visitMapEntryLabel(org.apache.groovy.parser.antlr4.GroovyParser.MapEntryLabelContext ctx)
    Specified by:
      `visitMapEntryLabel` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitMapEntryLabel` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitKeywords

    public ConstantExpression visitKeywords(org.apache.groovy.parser.antlr4.GroovyParser.KeywordsContext ctx)
    Specified by:
      `visitKeywords` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitKeywords` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitBuiltInType

    public VariableExpression visitBuiltInType(org.apache.groovy.parser.antlr4.GroovyParser.BuiltInTypeContext ctx)
    Specified by:
      `visitBuiltInType` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitBuiltInType` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitList

    public ListExpression visitList(org.apache.groovy.parser.antlr4.GroovyParser.ListContext ctx)
    Specified by:
      `visitList` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitList` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitExpressionList

    public List<Expression> visitExpressionList(org.apache.groovy.parser.antlr4.GroovyParser.ExpressionListContext ctx)
    Specified by:
      `visitExpressionList` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitExpressionList` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitExpressionListElement

    public Expression visitExpressionListElement(org.apache.groovy.parser.antlr4.GroovyParser.ExpressionListElementContext ctx)
    Specified by:
      `visitExpressionListElement` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitExpressionListElement` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitIntegerLiteralAlt

    public ConstantExpression visitIntegerLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser.IntegerLiteralAltContext ctx)
    Specified by:
      `visitIntegerLiteralAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitIntegerLiteralAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitFloatingPointLiteralAlt

    public ConstantExpression visitFloatingPointLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser.FloatingPointLiteralAltContext ctx)
    Specified by:
      `visitFloatingPointLiteralAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitFloatingPointLiteralAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitBooleanLiteralAlt

    public ConstantExpression visitBooleanLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser.BooleanLiteralAltContext ctx)
    Specified by:
      `visitBooleanLiteralAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitBooleanLiteralAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitNullLiteralAlt

    public ConstantExpression visitNullLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser.NullLiteralAltContext ctx)
    Specified by:
      `visitNullLiteralAlt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitNullLiteralAlt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitGstring

    public GStringExpression visitGstring(org.apache.groovy.parser.antlr4.GroovyParser.GstringContext ctx)
    Specified by:
      `visitGstring` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitGstring` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitGstringValue

    public Expression visitGstringValue(org.apache.groovy.parser.antlr4.GroovyParser.GstringValueContext ctx)
    Specified by:
      `visitGstringValue` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitGstringValue` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitGstringPath

    public Expression visitGstringPath(org.apache.groovy.parser.antlr4.GroovyParser.GstringPathContext ctx)
    Specified by:
      `visitGstringPath` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitGstringPath` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitStandardLambdaExpression

    public LambdaExpression visitStandardLambdaExpression(org.apache.groovy.parser.antlr4.GroovyParser.StandardLambdaExpressionContext ctx)
    Specified by:
      `visitStandardLambdaExpression` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitStandardLambdaExpression` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitStandardLambdaParameters

    public Parameter[] visitStandardLambdaParameters(org.apache.groovy.parser.antlr4.GroovyParser.StandardLambdaParametersContext ctx)
    Specified by:
      `visitStandardLambdaParameters` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitStandardLambdaParameters` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitLambdaBody

    public Statement visitLambdaBody(org.apache.groovy.parser.antlr4.GroovyParser.LambdaBodyContext ctx)
    Specified by:
      `visitLambdaBody` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitLambdaBody` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitClosure

    public ClosureExpression visitClosure(org.apache.groovy.parser.antlr4.GroovyParser.ClosureContext ctx)
    Specified by:
      `visitClosure` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitClosure` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitFormalParameters

    public Parameter[] visitFormalParameters(org.apache.groovy.parser.antlr4.GroovyParser.FormalParametersContext ctx)
    Specified by:
      `visitFormalParameters` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitFormalParameters` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitFormalParameterList

    public Parameter[] visitFormalParameterList(org.apache.groovy.parser.antlr4.GroovyParser.FormalParameterListContext ctx)
    Specified by:
      `visitFormalParameterList` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitFormalParameterList` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitFormalParameter

    public Parameter visitFormalParameter(org.apache.groovy.parser.antlr4.GroovyParser.FormalParameterContext ctx)
    Specified by:
      `visitFormalParameter` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitFormalParameter` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitThisFormalParameter

    public Parameter visitThisFormalParameter(org.apache.groovy.parser.antlr4.GroovyParser.ThisFormalParameterContext ctx)
    Specified by:
      `visitThisFormalParameter` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitThisFormalParameter` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitClassOrInterfaceModifiersOpt

    public List<ModifierNode> visitClassOrInterfaceModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser.ClassOrInterfaceModifiersOptContext ctx)
    Specified by:
      `visitClassOrInterfaceModifiersOpt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitClassOrInterfaceModifiersOpt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitClassOrInterfaceModifiers

    public List<ModifierNode> visitClassOrInterfaceModifiers(org.apache.groovy.parser.antlr4.GroovyParser.ClassOrInterfaceModifiersContext ctx)
    Specified by:
      `visitClassOrInterfaceModifiers` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitClassOrInterfaceModifiers` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitClassOrInterfaceModifier

    public ModifierNode visitClassOrInterfaceModifier(org.apache.groovy.parser.antlr4.GroovyParser.ClassOrInterfaceModifierContext ctx)
    Specified by:
      `visitClassOrInterfaceModifier` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitClassOrInterfaceModifier` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitModifier

    public ModifierNode visitModifier(org.apache.groovy.parser.antlr4.GroovyParser.ModifierContext ctx)
    Specified by:
      `visitModifier` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitModifier` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitModifiers

    public List<ModifierNode> visitModifiers(org.apache.groovy.parser.antlr4.GroovyParser.ModifiersContext ctx)
    Specified by:
      `visitModifiers` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitModifiers` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitModifiersOpt

    public List<ModifierNode> visitModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser.ModifiersOptContext ctx)
    Specified by:
      `visitModifiersOpt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitModifiersOpt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitVariableModifier

    public ModifierNode visitVariableModifier(org.apache.groovy.parser.antlr4.GroovyParser.VariableModifierContext ctx)
    Specified by:
      `visitVariableModifier` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitVariableModifier` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitVariableModifiersOpt

    public List<ModifierNode> visitVariableModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser.VariableModifiersOptContext ctx)
    Specified by:
      `visitVariableModifiersOpt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitVariableModifiersOpt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitVariableModifiers

    public List<ModifierNode> visitVariableModifiers(org.apache.groovy.parser.antlr4.GroovyParser.VariableModifiersContext ctx)
    Specified by:
      `visitVariableModifiers` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitVariableModifiers` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitEmptyDims

    public List<List<AnnotationNode>> visitEmptyDims(org.apache.groovy.parser.antlr4.GroovyParser.EmptyDimsContext ctx)
    Specified by:
      `visitEmptyDims` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitEmptyDims` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitEmptyDimsOpt

    public List<List<AnnotationNode>> visitEmptyDimsOpt(org.apache.groovy.parser.antlr4.GroovyParser.EmptyDimsOptContext ctx)
    Specified by:
      `visitEmptyDimsOpt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitEmptyDimsOpt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitType

    public ClassNode visitType(org.apache.groovy.parser.antlr4.GroovyParser.TypeContext ctx)
    Specified by:
      `visitType` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitType` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitClassOrInterfaceType

    public ClassNode visitClassOrInterfaceType(org.apache.groovy.parser.antlr4.GroovyParser.ClassOrInterfaceTypeContext ctx)
    Specified by:
      `visitClassOrInterfaceType` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitClassOrInterfaceType` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitTypeArgumentsOrDiamond

    public GenericsType[] visitTypeArgumentsOrDiamond(org.apache.groovy.parser.antlr4.GroovyParser.TypeArgumentsOrDiamondContext ctx)
    Specified by:
      `visitTypeArgumentsOrDiamond` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitTypeArgumentsOrDiamond` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitTypeArguments

    public GenericsType[] visitTypeArguments(org.apache.groovy.parser.antlr4.GroovyParser.TypeArgumentsContext ctx)
    Specified by:
      `visitTypeArguments` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitTypeArguments` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitTypeArgument

    public GenericsType visitTypeArgument(org.apache.groovy.parser.antlr4.GroovyParser.TypeArgumentContext ctx)
    Specified by:
      `visitTypeArgument` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitTypeArgument` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitPrimitiveType

    public ClassNode visitPrimitiveType(org.apache.groovy.parser.antlr4.GroovyParser.PrimitiveTypeContext ctx)
    Specified by:
      `visitPrimitiveType` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitPrimitiveType` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitVariableDeclaratorId

    public VariableExpression visitVariableDeclaratorId(org.apache.groovy.parser.antlr4.GroovyParser.VariableDeclaratorIdContext ctx)
    Specified by:
      `visitVariableDeclaratorId` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitVariableDeclaratorId` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitVariableNames

    public TupleExpression visitVariableNames(org.apache.groovy.parser.antlr4.GroovyParser.VariableNamesContext ctx)
    Specified by:
      `visitVariableNames` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitVariableNames` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitClosureOrLambdaExpression

    public ClosureExpression visitClosureOrLambdaExpression(org.apache.groovy.parser.antlr4.GroovyParser.ClosureOrLambdaExpressionContext ctx)
    Specified by:
      `visitClosureOrLambdaExpression` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitClosureOrLambdaExpression` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitBlockStatementsOpt

    public BlockStatement visitBlockStatementsOpt(org.apache.groovy.parser.antlr4.GroovyParser.BlockStatementsOptContext ctx)
    Specified by:
      `visitBlockStatementsOpt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitBlockStatementsOpt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitBlockStatements

    public BlockStatement visitBlockStatements(org.apache.groovy.parser.antlr4.GroovyParser.BlockStatementsContext ctx)
    Specified by:
      `visitBlockStatements` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitBlockStatements` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitBlockStatement

    public Statement visitBlockStatement(org.apache.groovy.parser.antlr4.GroovyParser.BlockStatementContext ctx)
    Specified by:
      `visitBlockStatement` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitBlockStatement` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitAnnotationsOpt

    public List<AnnotationNode> visitAnnotationsOpt(org.apache.groovy.parser.antlr4.GroovyParser.AnnotationsOptContext ctx)
    Specified by:
      `visitAnnotationsOpt` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitAnnotationsOpt` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitAnnotation

    public AnnotationNode visitAnnotation(org.apache.groovy.parser.antlr4.GroovyParser.AnnotationContext ctx)
    Specified by:
      `visitAnnotation` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitAnnotation` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitElementValues

    public List<Tuple2<String,Expression>> visitElementValues(org.apache.groovy.parser.antlr4.GroovyParser.ElementValuesContext ctx)
    Specified by:
      `visitElementValues` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitElementValues` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitAnnotationName

    public String visitAnnotationName(org.apache.groovy.parser.antlr4.GroovyParser.AnnotationNameContext ctx)
    Specified by:
      `visitAnnotationName` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitAnnotationName` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitElementValuePairs

    public Map<String,Expression> visitElementValuePairs(org.apache.groovy.parser.antlr4.GroovyParser.ElementValuePairsContext ctx)
    Specified by:
      `visitElementValuePairs` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitElementValuePairs` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitElementValuePair

    public Tuple2<String,Expression> visitElementValuePair(org.apache.groovy.parser.antlr4.GroovyParser.ElementValuePairContext ctx)
    Specified by:
      `visitElementValuePair` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitElementValuePair` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitElementValue

    public Expression visitElementValue(org.apache.groovy.parser.antlr4.GroovyParser.ElementValueContext ctx)
    Specified by:
      `visitElementValue` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitElementValue` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitElementValueArrayInitializer

    public ListExpression visitElementValueArrayInitializer(org.apache.groovy.parser.antlr4.GroovyParser.ElementValueArrayInitializerContext ctx)
    Specified by:
      `visitElementValueArrayInitializer` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitElementValueArrayInitializer` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitClassName

    public String visitClassName(org.apache.groovy.parser.antlr4.GroovyParser.ClassNameContext ctx)
    Specified by:
      `visitClassName` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitClassName` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitIdentifier

    public String visitIdentifier(org.apache.groovy.parser.antlr4.GroovyParser.IdentifierContext ctx)
    Specified by:
      `visitIdentifier` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitIdentifier` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitQualifiedName

    public String visitQualifiedName(org.apache.groovy.parser.antlr4.GroovyParser.QualifiedNameContext ctx)
    Specified by:
      `visitQualifiedName` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitQualifiedName` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitAnnotatedQualifiedClassName

    public ClassNode visitAnnotatedQualifiedClassName(org.apache.groovy.parser.antlr4.GroovyParser.AnnotatedQualifiedClassNameContext ctx)
    Specified by:
      `visitAnnotatedQualifiedClassName` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitAnnotatedQualifiedClassName` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitQualifiedClassNameList

    public ClassNode[] visitQualifiedClassNameList(org.apache.groovy.parser.antlr4.GroovyParser.QualifiedClassNameListContext ctx)
    Specified by:
      `visitQualifiedClassNameList` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitQualifiedClassNameList` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitQualifiedClassName

    public ClassNode visitQualifiedClassName(org.apache.groovy.parser.antlr4.GroovyParser.QualifiedClassNameContext ctx)
    Specified by:
      `visitQualifiedClassName` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitQualifiedClassName` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visitQualifiedStandardClassName

    public ClassNode visitQualifiedStandardClassName(org.apache.groovy.parser.antlr4.GroovyParser.QualifiedStandardClassNameContext ctx)
    Specified by:
      `visitQualifiedStandardClassName` in interface `org.apache.groovy.parser.antlr4.GroovyParserVisitor<Object>`
    Overrides:
      `visitQualifiedStandardClassName` in class `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor<Object>`

  - ### visit

    public Object visit(org.antlr.v4.runtime.tree.ParseTree tree)
    Visit tree safely, no NPE occurred when the tree is null.
    Specified by:
      `visit` in interface `org.antlr.v4.runtime.tree.ParseTreeVisitor<Object>`
    Overrides:
      `visit` in class `org.antlr.v4.runtime.tree.AbstractParseTreeVisitor<Object>`
    Parameters:
      `tree` - an AST node
    Returns:
      the visiting result

  - ### appendStatementsToBlockStatement

    public BlockStatement appendStatementsToBlockStatement(BlockStatement bs, Statement... statements)